#!/usr/bin/env bash

declare -i cur_vol
cur_vol=`audtool get-volume`

declare -i targ_vol
targ_vol=$1
if [ $targ_vol -lt 0 ]; then
  targ_vol=0
fi
if [ $targ_vol -gt 100 ]; then
  targ_vol=100
fi

if [ $cur_vol -eq $targ_vol ]; then
  exit
fi

declare -i adj
adj=targ_vol-cur_vol
if [ $adj -lt 0 ]; then
  adj=adj*-1
fi

declare -i step_time
step_time=adj*20
step_time=step_time*step_time*3/2

declare -i adj_step
adj_step=1
if [ $cur_vol -gt $targ_vol ]; then
  adj_step=-1
fi

declare -i sleep_time
sleep_time=$2
if [ $sleep_time -eq 0 ]; then
  sleep_time=5
fi
sleep_time=sleep_time*1000000
sleep_time=sleep_time-step_time
sleep_time=sleep_time/adj
if  [ $sleep_time -lt 1 ]; then
  sleep_time=1
fi

echo "cur=" $cur_vol " targ=" $targ_vol " delta=" $adj " sleep=" $sleep_time " step=" $adj_step " step_time=" $step_time

while [ $cur_vol != $targ_vol ]; do
  cur_vol=cur_vol+adj_step
#  echo " setting volume to : " $cur_vol
  `audtool set-volume $cur_vol`
  ./nsleep $sleep_time
done
